const Shell   = imports.gi.Shell;
const GLib    = imports.gi.GLib;
const Meta    = imports.gi.Meta;
const Gio     = imports.gi.Gio;
const Utils   = imports.misc.extensionUtils.getCurrentExtension().imports.utils; 
const Tweener = imports.ui.tweener;
const Gettext = imports.gettext.domain('toggle_nautilus@kirby33');
const _ = Gettext.gettext;
const Config = imports.misc.config;
const key_bindings = {'toggle-nautilus': function() {_toggleNautilus();}};
const mySettings = Utils.getSettings();

function _toggleNautilus() {
	let win = _getWindowActor();
	if (win === 'start') {
		_startApplication();
		return;
	}
        if (!win) {
            return;
        }
        // minimize/unmaximize
        if (win.minimized) {
		win.unminimize();
		win.activate(global.get_current_time());
        } else {
		win.minimize();
        }
}

function _startApplication(){
	imports.misc.util.trySpawnCommandLine('/usr/bin/nautilus');
}

function _getWindowActor(){
	let ApplicationString = _("nautilus.desktop");
	let window =Shell.AppSystem.get_default().lookup_app(ApplicationString).get_windows()[0];
	if(typeof window == 'undefined') { window = 'start';}
	return window;
}

function init(meta) {
	Utils.initTranslations("toggle_nautilus@kirby33");
}

function enable() {
	for(key in key_bindings) {
		global.display.add_keybinding(key,mySettings,Meta.KeyBindingFlags.NONE,key_bindings[key]);
	}
}

function disable() {
	for(key in key_bindings) {
		global.display.remove_keybinding(key);
	}
}
